//----------------------------------------------------------------------------//
//  MODEL       :  OpenSOAP
//  GROUP       :  Use SAX Server Side Service
//  MODULE      :  SocketService.java
//  ABSTRACT    :  Calc Service
//  DATE        :  2002.02.20
//  DESIGNED    :  Sunbit System k.Kuwa
//----------------------------------------------------------------------------//
//  UpDate                                                                
//  No.         Registration Of Alteration            Date          User
//----------------------------------------------------------------------------//
//..+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8
import java.io.*;
import java.net.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class SocketService {
    static int port = 0;

    //--------------------------------------------------------------------------
    // Socket Line Reader
    //--------------------------------------------------------------------------
    private static String readLine( DataInputStream inS ) throws Exception{
        try{
            StringBuffer s = new StringBuffer();
            for( int i = 0 ; ; ){
	        int c = inS.readUnsignedByte();
                Character element = new Character( (char)c);
	        s.append( element );
                if( c == '\n' || c == '\r' || s.toString().indexOf("</SOAP-ENV:Envelope>") >= 0) {
                    break;
                }
            }
            return s.toString();
        } catch( EOFException e ){      // EOF
            return null;
        }
    }   // end of readLine()  

    //--------------------------------------------------------------------------
    // Service Main
    //--------------------------------------------------------------------------
    public static void main(String argv[]) throws IOException, OpenSoapException {
        String soapMessage;                                      // bZ[Wi[
        int sw;                                                  // bZ[WJnSW
        ServerSocket servSock = null;

        if(argv.length != 1){                                    // p[^`FbN
            System.out.println("Usage: java SocketService [<port>]");
            System.exit(1);
        }
        port = Integer.parseInt(argv[0]);

        try {                                                    // \Pbg̍쐬
            servSock = new ServerSocket( port );
        } catch(IOException e){
            System.out.println( "Exception(Port): " + e );
            System.exit(1);
        }

        for(;;){
            Socket theSock = null;                               // \Pbg
            try {                                                // RlNV҂
                theSock = servSock.accept();
            } catch(IOException e){
                System.out.println( "Exception(accept): " + e );
                System.exit(1);
            }
            sw = 0;
            soapMessage = "";
            try {                                                // MXg[쐬
                DataOutputStream outS =
                             new DataOutputStream(theSock.getOutputStream());
                DataInputStream  inS  =
                             new DataInputStream(theSock.getInputStream());
                for(;;){
                    String r = readLine(inS);                   // TCPf[^Ǎ
                    if( r.indexOf("<?xml version='1.0'?>") >= 0){
                        sw = 1;                                 // XML͊Jn
                    }
                    if( sw == 1){
                        soapMessage = soapMessage + r;          // XML͊i[
                    }
                    if( r.indexOf("</SOAP-ENV:Envelope>") >= 0){// SOAPbZ[WI
                        CharArrayWriter payload = new CharArrayWriter();
                        try {
                            // bZ[W̃p[X
                            XMLReader xr = XMLReaderFactory.createXMLReader(
                                           OpenSoapConstants.SAXPARSER);
                            xr.setFeature(OpenSoapConstants.SAXNAMESPACES,true);
                            CalcServiceResponse response = new CalcServiceResponse();
                            xr.setContentHandler(response);
                            StringReader sr = new StringReader(soapMessage.toString()); 
                            org.xml.sax.InputSource inputXML = new org.xml.sax.InputSource(sr); 
	                    xr.parse(inputXML);
                            // X|X쐬
                            response.writeResponse(payload);
                        } catch(OpenSoapException e) {          // OpenSOAPG[o
                            e.writeTo(payload);
                        } catch (Exception e) {                 // I/OG[o
                            System.out.println( "Exception(read): " + e );
 	                    e.printStackTrace();
                            System.exit(1);
	                }
                        // X|Xo
                        outS.writeBytes( "HTTP/1.1 200 OK\r\n");
                        outS.writeBytes( "Content-Type: text/xml; charset=\"UTF-8\"\r\n");
                        outS.writeBytes( "Content-Length: " + payload.size() + "\r\n\r\n");
                        outS.writeBytes( payload.toString());
                        outS.flush();
                        outS.close();
                        inS.close();
                        theSock.close();
                        break;
	            }
                }
            } catch( Exception e ){
                System.out.println( "Exception(I/O): " + e );
                System.exit(1);
            }
        }
    }
}
