# -----------------------------------------------------------------------------
#  $RCSfile: Hello.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------

PROGRAMS = HelloClient HelloService HelloService.cgi

OPENSOAP_PREFIX=/usr/local
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

CGI_BIN_DIR=/home/httpd/cgi-bin/

XML2_LIBS=`xml2-config --libs`

CFLAGS=-I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"
COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient
SERVICE_LDFLAGS=$(CLIENT_LDFLAGS) -lOpenSOAPService

SOURCES = HelloClient.c HelloService.c
OBJS=$(SOURCES:.c=.o) HelloService.cgi.o

all: $(PROGRAMS)

## Make Client Programs

HelloClient: HelloClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS) $(XML2_LIBS)

## Make Service Programs

HelloService.cgi.o: HelloService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

HelloService: HelloService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

HelloService.cgi: HelloService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

## Install Service Programs

install: $(PROGRAMS)
	cp HelloService.cgi $(CGI_BIN_DIR)
	cp HelloService /usr/local/sbin/
	cp Hello.ssml /var/tmp/OpenSOAP/conf/ssml/


clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Service Programs

stest:
	cat hello_request.xml | ./HelloService.cgi

## Test Client-Service (or Client-Server-Service) Hookups

ctest:
	./HelloClient foo

