# -----------------------------------------------------------------------------
#  $RCSfile: GetCert.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------

PROGRAMS = CA_Refer GetCertClient GetCertService GetCertService.cgi

OPENSOAP_PREFIX=/usr/local
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

CGI_BIN_DIR=/var/www/cgi-bin/

XML2_LIBS=`xml2-config --libs`

# CFLAGS=-I$(OPENSOAP_INCLUDE)
CFLAGS=-I$(OPENSOAP_INCLUDE) -I../../include -O2
#CFLAGS=-I$(OPENSOAP_INCLUDE) -I../../include -g

CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"
COMMON_LDFLAGS=../../lib/libossec.a -lcrypto -L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient
SERVICE_LDFLAGS=$(CLIENT_LDFLAGS) -lOpenSOAPService

SOURCES = GetCertClient.c GetCertService.c DBrefer.c
OBJS=$(SOURCES:.c=.o) GetCertService.cgi.o

all: $(PROGRAMS)

## Make Client Programs

GetCertClient: GetCertClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS) $(XML2_LIBS)

## Make Service Programs

GetCertService.cgi.o: GetCertService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

GetCertService: GetCertService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

GetCertService.cgi: GetCertService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

CA_Refer: DBrefer.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS) $(XML2_LIBS)

## Install Service Programs

install: $(PROGRAMS)
	cp GetCertService.cgi $(CGI_BIN_DIR)
	cp GetCertService /usr/local/sbin/
	cp CA_Refer /usr/local/sbin
	chmod u+s /usr/local/sbin/CA_Refer
	cp CA.db CA.db_sno /var/tmp/OpenSOAP/Data/Security/

clean: 
	rm -f $(OBJS) $(PROGRAMS) *~ core pubKey_res.pem result.cert


## Test Client-Service (or Client-Server-Service) Hookups

ctest:
	./GetCertClient "David Beckham"
